<template>
  <q-card
    flat
    class="q-mt-lg rounded-borders-10"
    :class="{
      'q-pa-sm': screenWidth >= 768 && screenWidth <= 899,
      'q-pa-lg': screenWidth >= 900,
    }"
  >
    <q-card-section>
      <div class="row">
        <div class="col-3 q-my-auto">
          <label class="title-headline"> Work History </label>
        </div>

        <q-spacer />

        <div class="col" align="right">
          <q-btn
            unelevated
            no-caps
            text
            label="Add"
            icon="add"
            class="btn-md text-primary"
            @click="showAddWork(), (showAddDialog = true)"
          />
        </div>
      </div>
    </q-card-section>

    <q-card-section>
      <div
        class="row q-mb-lg"
        v-for="(work, k) in workStore.workHistories"
        :key="k"
      >
        <div class="col q-mr-xl" :class="{ 'col-12': $q.screen.lt.sm }">
          <div class="row">
            <div class="col">
              <div class="row">
                <div class="col-6">
                  <p
                    class="text-caption text-weight-bold text-grey-6"
                    style="font-size: 11px"
                  >
                    COMPANY
                  </p>
                </div>
                <div class="col-6">
                  <p>{{ work.company_name }}</p>
                </div>

                <div class="col-6">
                  <p
                    class="text-caption text-weight-bold text-grey-6"
                    style="font-size: 11px"
                  >
                    TITLE
                  </p>
                </div>
                <div class="col-6">
                  <p>{{ work.title }}</p>
                </div>

                <div class="col-6">
                  <p
                    class="text-caption text-weight-bold text-grey-6"
                    style="font-size: 11px"
                  >
                    EMPLOYMENT DATES
                  </p>
                </div>
                <div class="col-6">
                  <p>{{ work.date_from + " - " + work.date_to }}</p>
                </div>

                <div class="col-6">
                  <p
                    class="text-caption text-weight-bold text-grey-6"
                    style="font-size: 11px"
                  >
                    UPLOAD COE
                  </p>
                </div>
                <div class="col-6">
                  <a :href="work.certificate_of_employment_url" target="_blank">
                    <p style="overflow: hidden; text-overflow: ellipsis">
                      {{ work.certificate_of_employment_url }}
                    </p>
                  </a>
                </div>
              </div>
            </div>
          </div>
        </div>

        <div class="col" :class="{ 'col-12': $q.screen.lt.sm }">
          <div class="row">
            <div class="col">
              <div class="row">
                <div class="col-6">
                  <p
                    class="text-caption text-weight-bold text-grey-6"
                    style="font-size: 11px"
                  >
                    REFERENCE NAME
                  </p>
                </div>
                <div class="col-6">
                  <p style="overflow: hidden; word-break: break-all">
                    {{ work.contact_name }}
                  </p>
                </div>

                <div class="col-6">
                  <p
                    class="text-caption text-weight-bold text-grey-6"
                    style="font-size: 11px"
                  >
                    CONTACT NUMBER
                  </p>
                </div>
                <div class="col-6">
                  <p style="overflow: hidden; word-break: break-all">
                    {{ work.contact_number }}
                  </p>
                </div>

                <div class="col-6">
                  <p
                    class="text-caption text-weight-bold text-grey-6"
                    style="font-size: 11px"
                  >
                    EMAIL ADDRESS
                  </p>
                </div>
                <div class="col-6">
                  <p style="overflow: hidden; word-break: break-all">
                    {{ work.email }}
                  </p>
                </div>
              </div>
            </div>
          </div>
        </div>

        <div class="col-2" align="right" :class="{ 'col-12': $q.screen.lt.sm }">
          <q-btn
            unelevated
            size="md"
            icon="eva-edit-outline"
            class="btn-edit q-mr-xs text-grey-6"
            @click="showEditWork(work.id), (showEditDialog = true)"
          />

          <q-btn
            unelevated
            size="md"
            icon="eva-trash-outline"
            class="btn-edit text-grey-6"
            @click="showDeleteWork(work.id), (showDeleteDialog = true)"
          />
        </div>
        <!-- <div class="col q-mr-xl" :class="{ 'col-12': $q.screen.lt.sm }">
          <div class="row">
            <div class="col">
              <p
                class="text-caption text-weight-bold text-grey-6 q-mt-xs"
                style="font-size: 11px"
              >
                COMPANY
              </p>
              <p
                class="text-caption text-weight-bold text-grey-6 q-mt-xs"
                style="font-size: 11px"
              >
                TITLE
              </p>
              <p
                class="text-caption text-weight-bold text-grey-6 q-mt-xs"
                style="font-size: 11px"
              >
                EMPLOYMENT DATES
              </p>
              <p
                class="text-caption text-weight-bold text-grey-6 q-mt-xs"
                style="font-size: 11px"
              >
                UPLOAD COE
              </p>
            </div>

            <div class="col">
              <p>{{ work.company_name }}</p>
              <p>{{ work.title }}</p>
              <p>{{ work.date_from + " - " + work.date_to }}</p>
              <a :href="work.certificate_of_employment_url" target="_blank">
                <p style="overflow: hidden; text-overflow: ellipsis">
                  {{ work.certificate_of_employment_url }}
                </p>
              </a>
            </div>
          </div>
        </div>

        <div class="col" :class="{ 'col-12': $q.screen.lt.sm }">
          <div class="row">
            <div class="col">
              <p
                class="text-caption text-weight-bold text-grey-6 q-mt-xs"
                style="font-size: 11px"
              >
                REFERENCE NAME
              </p>
              <p
                class="text-caption text-weight-bold text-grey-6 q-mt-xs"
                style="font-size: 11px"
              >
                CONTACT NUMBER
              </p>
              <p
                class="text-caption text-weight-bold text-grey-6 q-mt-xs"
                style="font-size: 11px"
              >
                EMAIL ADDRESS
              </p>
            </div>

            <div class="col">
              <p>{{ work.contact_name }}</p>
              <p>{{ work.contact_number }}</p>
              <p style="overflow: hidden; text-overflow: ellipsis">
                {{ work.email }}
              </p>
            </div>
          </div>
        </div>

        <div class="col" align="right" :class="{ 'col-12': $q.screen.lt.sm }">
          <q-btn
            unelevated
            size="md"
            icon="eva-edit-outline"
            class="btn-edit q-mr-xs text-grey-6"
            @click="showEditWork(work.id), (showEditDialog = true)"
          />

          <q-btn
            unelevated
            size="md"
            icon="eva-trash-outline"
            class="btn-edit text-grey-6"
            @click="showDeleteWork(work.id), (showDeleteDialog = true)"
          />
        </div> -->
      </div>
    </q-card-section>
  </q-card>

  <!-- DIALOG: ADD WORK HISTORY  -->
  <q-dialog v-model="showAddDialog" persistent @hide="showAddDialog === false">
    <q-card
      flat
      class="q-pa-sm q-mt-lg rounded-borders-10"
      style="width: 1300px; max-width: 90vw"
    >
      <q-card-section class="row items-center q-pb-none">
        <span class="title-headline text-green-10">Add Work History</span>
        <q-space />
        <q-btn size="md" icon="eva-close" flat round dense v-close-popup />
      </q-card-section>

      <q-card-section>
        <q-form @submit="addDetails(form2)">
          <div id="form-details">
            <q-card
              v-for="(work, k) in form2.work_histories"
              :key="k"
              flat
              bordered
              class="q-pa-lg rounded-borders-10 q-mb-md"
            >
              <div
                v-if="form2.work_histories.length > 1"
                class="text-right text-negative"
              >
                <q-btn
                  unelevated
                  no-caps
                  text
                  label="Remove Work"
                  icon="remove"
                  class="btn-md"
                  @click="removeRowWork(k)"
                />
              </div>

              <div class="row q-pb-sm">
                <div class="col q-mr-lg" :class="{ 'col-12': $q.screen.lt.sm }">
                  <div class="q-py-xs">
                    <label class="text-caption text-weight-bold text-grey-6"
                      >COMPANY NAME
                      <span v-if="work.company_name" class="text-negative"
                        >*</span
                      ></label
                    >
                    <q-input
                      v-model="work.company_name"
                      dense
                      outlined
                      class="q-mt-sm"
                      autofocus
                    />
                  </div>
                </div>

                <div class="col"></div>
                <div class="col"></div>
              </div>

              <div class="row q-pb-sm">
                <div class="col q-mr-lg" :class="{ 'col-12': $q.screen.lt.sm }">
                  <div class="q-py-xs">
                    <label class="text-caption text-weight-bold text-grey-6"
                      >TITLE</label
                    >
                    <q-input
                      v-model="work.title"
                      dense
                      outlined
                      class="q-mt-sm"
                      :disable="work.company_name === null"
                    />
                  </div>
                </div>

                <div class="col q-mr-lg" :class="{ 'col-12': $q.screen.lt.sm }">
                  <div class="q-py-xs">
                    <label class="text-caption text-weight-bold text-grey-6"
                      >EMPLOYMENT DATE</label
                    >
                    <div class="row">
                      <div class="col q-mr-md">
                        <q-input
                          dense
                          outlined
                          v-model="work.date_from"
                          class="q-mt-sm"
                          mask="date"
                          :disable="work.company_name === null"
                        >
                          <template v-slot:append>
                            <q-icon
                              name="eva-calendar-outline"
                              class="cursor-pointer"
                            >
                              <q-popup-proxy
                                cover
                                transition-show="scale"
                                transition-hide="scale"
                              >
                                <q-date v-model="work.date_from">
                                  <div class="row items-center justify-end">
                                    <q-btn
                                      v-close-popup
                                      label="Close"
                                      color="primary"
                                      flat
                                    />
                                  </div>
                                </q-date>
                              </q-popup-proxy>
                            </q-icon>
                          </template>
                        </q-input>
                      </div>

                      <div class="col">
                        <q-input
                          dense
                          outlined
                          v-model="work.date_to"
                          class="q-mt-sm"
                          mask="date"
                          :disable="
                            work.company_name === null ||
                            work.date_from === null
                          "
                        >
                          <template v-slot:append>
                            <q-icon
                              name="eva-calendar-outline"
                              class="cursor-pointer"
                            >
                              <q-popup-proxy
                                cover
                                transition-show="scale"
                                transition-hide="scale"
                              >
                                <q-date v-model="work.date_to">
                                  <div class="row items-center justify-end">
                                    <q-btn
                                      v-close-popup
                                      label="Close"
                                      color="primary"
                                      flat
                                      @click="
                                        greaterThanDateFrom(
                                          work.date_from,
                                          work.date_to
                                        )
                                      "
                                    />
                                  </div>
                                </q-date>
                              </q-popup-proxy>
                            </q-icon>
                          </template>
                        </q-input>

                        <p
                          id="error"
                          class="q-field_messages text-negative q-pa-sm"
                          v-if="isError === true"
                        >
                          {{ errorMessage }}
                        </p>
                      </div>
                    </div>
                  </div>
                </div>

                <div class="col" :class="{ 'col-12': $q.screen.lt.sm }">
                  <div class="q-py-xs">
                    <label class="text-caption text-weight-bold text-grey-6"
                      >REFERENCE CONTACT NAME</label
                    >
                    <q-input
                      v-model="work.contact_name"
                      dense
                      outlined
                      class="q-mt-sm"
                      :disable="work.company_name === null"
                    />
                  </div>
                </div>
              </div>

              <div class="row">
                <div class="col q-mr-lg">
                  <div class="q-py-xs">
                    <label class="text-caption text-weight-bold text-grey-6"
                      >EMAIL ADDRESS</label
                    >
                    <q-input
                      v-model="work.email"
                      dense
                      outlined
                      class="q-mt-sm"
                      :rules="work.email ? [validations.emailFormat] : []"
                      :disable="work.company_name === null"
                    />
                  </div>
                </div>

                <div class="col q-mr-lg">
                  <div class="q-py-xs">
                    <label class="text-caption text-weight-bold text-grey-6"
                      >CONTACT NUMBER</label
                    >
                    <q-input
                      v-model="work.contact_number"
                      dense
                      outlined
                      class="q-mt-sm"
                      v-on:keyup="formatWorkContactNumber(work.contact_number)"
                      placeholder="xxx-xxx-xxxx"
                      maxlength="12"
                      :disable="work.company_name === null"
                    >
                      <template v-slot:prepend>
                        <span class="title-7">(+63)</span>
                      </template>
                    </q-input>
                  </div>
                </div>

                <div class="col" :class="{ 'col-12': $q.screen.lt.sm }">
                  <div class="q-py-xs">
                    <label class="text-caption text-weight-bold text-grey-6"
                      >UPLOAD CERTIFICATE OF EMPLOYMENT</label
                    >
                    <q-file
                      dense
                      outlined
                      v-model="work.certificate_of_employment"
                      class="q-mt-sm"
                      max-file-size="5242880"
                      :filter="checkFileTypeCOE"
                      @rejected="onRejected(work.certificate_of_employment)"
                      @update:model-value="
                        onRejected(work.certificate_of_employment)
                      "
                      :disable="work.company_name === null"
                    >
                      <template v-slot:prepend>
                        <q-icon name="eva-attach-outline" />
                      </template>
                    </q-file>
                    <p
                      id="error"
                      class="q-field_messages text-negative q-pa-sm"
                      v-if="isFileError === true"
                    >
                      {{ errorMessage }}
                    </p>
                  </div>
                </div>
              </div>
            </q-card>

            <div class="text-right text-primary q-mt-md">
              <q-btn
                unelevated
                no-caps
                text
                label="Add Work"
                icon="add"
                class="btn-md"
                @click="addRowWork()"
              />
            </div>
          </div>

          <div class="q-mt-xl flex justify-center">
            <q-btn
              unelevated
              class="btn-lg btn--shade-1 text-white"
              type="submit"
              label="SUBMIT"
              :loading="loading"
            />
          </div>
        </q-form>
      </q-card-section>
    </q-card>
  </q-dialog>

  <!-- DIALOG: EDIT WORK HISTORY  -->
  <q-dialog
    v-model="showEditDialog"
    persistent
    @hide="showEditDialog === false"
  >
    <q-card
      flat
      class="q-pa-sm q-mt-lg rounded-borders-10"
      style="width: 1300px; max-width: 90vw"
    >
      <q-card-section class="row items-center q-pb-none">
        <span class="title-headline text-green-10">Edit Work History</span>
        <q-space />
        <q-btn size="md" icon="eva-close" flat round dense v-close-popup />
      </q-card-section>

      <q-card-section>
        <q-form @submit="editDetails(form.id)">
          <div id="form-details">
            <div class="row q-pb-sm">
              <div class="col q-mr-lg">
                <div class="q-py-xs">
                  <label class="text-caption text-weight-bold text-grey-6"
                    >COMPANY NAME</label
                  >
                  <q-input
                    v-model="form.company_name"
                    dense
                    outlined
                    class="q-mt-sm"
                  />
                </div>
              </div>

              <div class="col"></div>
              <div class="col"></div>
            </div>

            <div class="row q-pb-sm">
              <div class="col q-mr-lg">
                <div class="q-py-xs">
                  <label class="text-caption text-weight-bold text-grey-6"
                    >TITLE</label
                  >
                  <q-input
                    v-model="form.title"
                    dense
                    outlined
                    class="q-mt-sm"
                  />
                </div>
              </div>

              <div class="col q-mr-lg">
                <div class="q-py-xs">
                  <label class="text-caption text-weight-bold text-grey-6"
                    >EMPLOYMENT DATE</label
                  >
                  <div class="row">
                    <div class="col q-mr-md">
                      <q-input
                        dense
                        outlined
                        v-model="form.date_from"
                        class="q-mt-sm"
                        mask="date"
                      >
                        <template v-slot:append>
                          <q-icon
                            name="eva-calendar-outline"
                            class="cursor-pointer"
                          >
                            <q-popup-proxy
                              cover
                              transition-show="scale"
                              transition-hide="scale"
                            >
                              <q-date v-model="form.date_from">
                                <div class="row items-center justify-end">
                                  <q-btn
                                    v-close-popup
                                    label="Close"
                                    color="primary"
                                    flat
                                  />
                                </div>
                              </q-date>
                            </q-popup-proxy>
                          </q-icon>
                        </template>
                      </q-input>
                    </div>

                    <div class="col">
                      <q-input
                        dense
                        outlined
                        v-model="form.date_to"
                        class="q-mt-sm"
                        mask="date"
                        :disable="form.date_from === null"
                      >
                        <template v-slot:append>
                          <q-icon
                            name="eva-calendar-outline"
                            class="cursor-pointer"
                          >
                            <q-popup-proxy
                              cover
                              transition-show="scale"
                              transition-hide="scale"
                            >
                              <q-date v-model="form.date_to">
                                <div class="row items-center justify-end">
                                  <q-btn
                                    v-close-popup
                                    label="Close"
                                    color="primary"
                                    flat
                                    @click="
                                      greaterThanDateFrom(
                                        form.date_from,
                                        form.date_to
                                      )
                                    "
                                  />
                                </div>
                              </q-date>
                            </q-popup-proxy>
                          </q-icon>
                        </template>
                      </q-input>

                      <p
                        id="error"
                        class="q-field_messages text-negative q-pa-sm"
                        v-if="isError === true"
                      >
                        {{ errorMessage }}
                      </p>
                    </div>
                  </div>
                </div>
              </div>

              <div class="col">
                <div class="q-py-xs">
                  <label class="text-caption text-weight-bold text-grey-6"
                    >REFERENCE CONTACT NAME</label
                  >
                  <q-input
                    v-model="form.contact_name"
                    dense
                    outlined
                    class="q-mt-sm"
                  />
                </div>
              </div>
            </div>

            <div class="row">
              <div class="col q-mr-lg">
                <div class="q-py-xs">
                  <label class="text-caption text-weight-bold text-grey-6"
                    >EMAIL ADDRESS</label
                  >
                  <q-input
                    v-model="form.email"
                    dense
                    outlined
                    class="q-mt-sm"
                    :rules="form.email ? [validations.emailFormat] : []"
                  />
                </div>
              </div>

              <div class="col q-mr-lg">
                <div class="q-py-xs">
                  <label class="text-caption text-weight-bold text-grey-6"
                    >CONTACT NUMBER</label
                  >
                  <q-input
                    v-model="form.contact_number"
                    dense
                    outlined
                    class="q-mt-sm"
                    v-on:keyup="
                      formatReferenceContactNumber(form.contact_number)
                    "
                    placeholder="xxx-xxx-xxxx"
                    maxlength="12"
                  >
                    <template v-slot:prepend>
                      <span class="title-7">(+63)</span>
                    </template>
                  </q-input>
                </div>
              </div>

              <div class="col">
                <div class="q-py-xs">
                  <label class="text-caption text-weight-bold text-grey-6"
                    >UPLOAD CERTIFICATE OF EMPLOYMENT</label
                  >
                  <q-file
                    dense
                    outlined
                    v-model="form.certificate_of_employment"
                    class="q-mt-sm"
                    max-file-size="5242880"
                    :label="
                      form.certificate_of_employment === null
                        ? form.certificate_of_employment_name
                        : 'Selected File'
                    "
                    :filter="checkFileTypeCOE"
                    @rejected="onRejected(form.certificate_of_employment)"
                    @update:model-value="
                      onRejected(form.certificate_of_employment)
                    "
                    @click="toggleFileNameVisibility"
                    @change="onFileChange"
                  >
                    <template v-slot:prepend>
                      <q-icon name="eva-attach-outline" />
                    </template>
                  </q-file>
                  <p
                    id="error"
                    class="q-field_messages text-negative q-pa-sm"
                    v-if="isFileError === true"
                  >
                    {{ errorMessage }}
                  </p>
                </div>
              </div>
            </div>
          </div>

          <div class="q-mt-xl flex justify-center">
            <q-btn
              unelevated
              class="btn-lg btn--shade-1 text-white q-mr-lg"
              type="submit"
              label="SUBMIT"
              :loading="loading"
            />
          </div>
        </q-form>
      </q-card-section>
    </q-card>
  </q-dialog>

  <!-- DIALOG: DELETE WORK HISTORY  -->
  <q-dialog
    v-model="showDeleteDialog"
    persistent
    @hide="showDeleteDialog === false"
  >
    <q-card
      flat
      class="q-pa-sm q-mt-lg rounded-borders-10"
      style="width: 600px; max-width: 80vw"
    >
      <q-card-section class="row items-center q-pb-none">
        <span class="title-headline text-green-10">Delete Work History</span>
        <q-space />
        <q-btn size="md" icon="eva-close" flat round dense v-close-popup />
      </q-card-section>

      <q-card-section class="q-pt-none">
        Are you sure you want to delete this entry?
      </q-card-section>

      <q-card-section>
        <div class="q-mt-xl flex justify-center">
          <q-btn
            unelevated
            class="btn-lg bg-negative text-white"
            :loading="deleteLoading"
            label="DELETE"
            @click="deleteDetails(form.id)"
          />
        </div>
      </q-card-section>
    </q-card>
  </q-dialog>
</template>

<script>
import { defineComponent, ref, reactive, onMounted, onUnmounted } from "vue";
import { useWorkHistory } from "../../store/work-history";
import { emailFormat } from "src/hooks/validations";
import useJobseekerHook from "../../hooks/jobseekerHook";

export default defineComponent({
  setup() {
    const workStore = useWorkHistory();
    const { getWorkHistories, showWorkHistory } = workStore;

    const { loading, deleteLoading, doCreateWork, doUpdateWork, doDeleteWork } =
      useJobseekerHook();
    const showAddDialog = ref(false);
    const showEditDialog = ref(false);
    const showDeleteDialog = ref(false);
    const isError = ref(false);
    const isFileError = ref(false);
    const errorMessage = ref("");
    const fileNameVisible = ref(true);
    const screenWidth = ref(0);

    const form = reactive({
      id: null,
      company_name: null,
      title: null,
      date_from: null,
      date_to: null,
      contact_name: null,
      contact_number: null,
      email: null,
      certificate_of_employment: null,
      certificate_of_employment_name: null,
      _method: "PUT",
    });

    const form2 = reactive({
      work_histories: [
        {
          company_name: null,
          title: null,
          date_from: null,
          date_to: null,
          contact_name: null,
          contact_number: null,
          email: null,
          certificate_of_employment: null,
        },
      ],
    });

    const fetchUserDetails = () => {
      getWorkHistories();
    };

    const formatWorkContactNumber = (number) => {
      let formattedNumber = number
        .replace(/\D+/g, "")
        .replace(/(\d{3})(\d{3})(\d{3})/, "$1-$2-$3");

      for (let index = 0; index < form2.work_histories.length; index++) {
        const work = form2.work_histories[index];

        if (work.contact_number) {
          work.contact_number = formattedNumber;
        }
      }
    };

    const formatReferenceContactNumber = (number) => {
      let formattedNumber = number
        .replace(/\D+/g, "")
        .replace(/(\d{3})(\d{3})(\d{3})/, "$1-$2-$3");

      if (form.contact_number) {
        form.contact_number = formattedNumber;
      }
    };

    const greaterThanDateFrom = (date_from, date_to) => {
      let dateFrom = new Date(date_from);
      let dateTo = new Date(date_to);

      if (dateTo && dateTo < dateFrom) {
        isError.value = true;
        errorMessage.value = "Date To should be greater than to Date From";
      } else {
        isError.value = false;
      }
    };

    const addRowWork = () => {
      form2.work_histories.push({
        company_name: null,
        title: null,
        date_from: null,
        contact_name: null,
        email: null,
        contact_number: null,
        certificate_of_employment: null,
      });
    };

    const removeRowWork = (index) => {
      form2.work_histories.splice(index, 1);
    };

    const showAddWork = () => {
      isError.value = false;
      isFileError.value = false;

      form2.work_histories = [
        {
          company_name: null,
          title: null,
          date_from: null,
          date_to: null,
          contact_name: null,
          email: null,
          contact_number: null,
          certificate_of_employment: null,
        },
      ];
    };

    const addDetails = async () => {
      const formData = new FormData();

      for (let i = 0; i < form2.work_histories.length; i++) {
        formData.append(
          `work_histories[${i}][company_name]`,
          form2.work_histories[i].company_name
        );
        formData.append(
          `work_histories[${i}][title]`,
          form2.work_histories[i].title
        );
        formData.append(
          `work_histories[${i}][date_from]`,
          form2.work_histories[i].date_from
        );
        formData.append(
          `work_histories[${i}][date_to]`,
          form2.work_histories[i].date_to
        );
        formData.append(
          `work_histories[${i}][contact_name]`,
          form2.work_histories[i].contact_name
        );
        formData.append(
          `work_histories[${i}][contact_number]`,
          form2.work_histories[i].contact_number
        );
        formData.append(
          `work_histories[${i}][email]`,
          form2.work_histories[i].email
        );
        formData.append(
          `work_histories[${i}][certificate_of_employment]`,
          form2.work_histories[i].certificate_of_employment
        );
      }

      await doCreateWork(formData);

      showAddDialog.value = false;
      fetchUserDetails();
    };

    const showEditWork = async (id) => {
      isError.value = false;
      isFileError.value = false;
      await showWorkHistory(id);

      form.id = workStore.workHistory.id;
      form.company_name = workStore.workHistory.company_name;
      form.title = workStore.workHistory.title;
      form.date_from = workStore.workHistory.date_from;
      form.date_to = workStore.workHistory.date_to;
      form.contact_name = workStore.workHistory.contact_name;
      form.contact_number = workStore.workHistory.contact_number;
      form.email = workStore.workHistory.email;
      form.certificate_of_employment_name =
        workStore.workHistory.certificate_of_employment_file_name;
    };

    const editDetails = async (id) => {
      if (form.certificate_of_employment === null) {
        await doUpdateWork(id, form);
      } else {
        const formData = new FormData();

        formData.append("company_name", form.company_name);
        formData.append("title", form.title);
        formData.append("date_from", form.date_from);
        formData.append("date_to", form.date_to);
        formData.append("contact_name", form.contact_name);
        formData.append("contact_number", form.contact_number);
        formData.append("email", form.email);
        formData.append(
          "certificate_of_employment",
          form.certificate_of_employment
        );
        formData.append("_method", form._method);

        await doUpdateWork(id, formData);
      }

      showEditDialog.value = false;
      fetchUserDetails();
    };

    const showDeleteWork = (id) => {
      form.id = id;
      showDeleteDialog.value = true;
    };

    const deleteDetails = async (id) => {
      await doDeleteWork(id);

      showDeleteDialog.value = false;
      fetchUserDetails();
    };

    const toggleFileNameVisibility = () => {
      fileNameVisible.value = !fileNameVisible.value;
    };

    const onFileChange = (newFile) => {
      form.certificate_of_employment = newFile;
    };

    onMounted(() => {
      window.addEventListener("resize", screenResize);
    });

    onUnmounted(() => {
      window.removeEventListener("resize", screenResize);
    });

    const screenResize = () => {
      screenWidth.value = window.innerWidth;
    };

    fetchUserDetails();
    screenResize();

    return {
      workStore,
      form,
      form2,
      showAddDialog,
      showEditDialog,
      showDeleteDialog,
      loading,
      deleteLoading,
      isError,
      isFileError,
      errorMessage,
      validations: {
        emailFormat,
      },
      checkFileTypeCOE(files) {
        return files.filter(
          (file) =>
            file.type === "application/msword" ||
            file.type ===
              "application/vnd.openxmlformats-officedocument.wordprocessingml.document" ||
            file.type === "application/pdf" ||
            file.type === "image/png" ||
            file.type === "image/jpeg" ||
            file.type === "image/jpg"
        );
      },
      onRejected(files) {
        for (let x = 0; x < files.length; x++) {
          const file = files[x];

          if (file.failedPropValidation === "max-file-size") {
            isFileError.value = true;
            errorMessage.value = "File size should not be greater than 5MB";
          } else if (file.failedPropValidation === "filter") {
            isFileError.value = true;
            errorMessage.value = "The file type uploaded is not supported";
          } else {
            isFileError.value = false;
            errorMessage.value = "";
          }
        }
      },
      showAddWork,
      showEditWork,
      showDeleteWork,
      addDetails,
      editDetails,
      deleteDetails,
      formatReferenceContactNumber,
      formatWorkContactNumber,
      addRowWork,
      removeRowWork,
      toggleFileNameVisibility,
      onFileChange,
      screenResize,
      screenWidth,
      greaterThanDateFrom,
    };
  },
});
</script>

<style lang="scss" scoped>
.btn-edit {
  border-radius: 50px !important;
  padding: 5px !important;
}
</style>
